import 'package:flutter_custom_toolbox/flutter_toolbox.dart';

import 'package:spotifyplaylistgenerator/config/default_activity_settings.dart';

class ActivitySettings {
  final String layout;

  ActivitySettings({
    required this.layout,
  });

  static String getLayoutValueFromUnsafe(String layout) {
    if (DefaultActivitySettings.allowedLayoutValues.contains(layout)) {
      return layout;
    }

    return DefaultActivitySettings.defaultLayoutValue;
  }

  factory ActivitySettings.createDefault() {
    return ActivitySettings(
      layout: DefaultActivitySettings.defaultLayoutValue,
    );
  }

  void dump() {
    printlog('$ActivitySettings:');
    printlog('  ${DefaultActivitySettings.parameterCodeLayout}: $layout');
    printlog('');
  }

  @override
  String toString() {
    return '$ActivitySettings(${toJson()})';
  }

  Map<String, dynamic>? toJson() {
    return <String, dynamic>{
      DefaultActivitySettings.parameterCodeLayout: layout,
    };
  }
}
